include 'Vram.inc'
include "VVram.inc"

ext Ascii_, Chars_
ext VVram_

ext @Temp@Word
ext @Temp@Word2
ext @Temp@Word3
ext @Temp@Word4
ext @Temp@Byte
ext @Temp@Byte2

pVram equ @Temp@Word
pChars equ @Temp@Word2
pVVram equ @Temp@Word3
pBackup equ @Temp@Word4
yCount equ @Temp@Byte
xCount equ @Temp@Byte2

dseg
Backup_: public Backup_
    defs VVramWidth*VVramHeight

cseg
Put1: 
    staa <pChars+1 | clr <pChars
    asl <pChars+1 | rol <pChars ;*2
    asl <pChars+1 | rol <pChars ;*4
    ldab <pChars+1 | addb #low Chars_ | stab <pChars+1
    ldab <pChars | adcb #high Chars_ | stab <pChars
    
    ldab #CharHeight
    do
        ldx <pChars | ldaa 0,x | inx | stx <pChars
        ldx <pVram
        staa 0,x
        ldaa <pVram+1 | adda #VramWidth | staa <pVram+1
        decb
    while ne | wend
    ldaa <pVram+1 | adda #1-VramRowSize | staa <pVram+1
rts


; void VVramToVram();
VVramToVram_: public VVramToVram_
    psha | pshb
        ldx #VVram_ | stx <pVVram
        ldx #Backup_ | stx <pBackup
        ldx #Vram+VramRowSize*2 | stx <pVram
        ldaa #VVramHeight
        staa <yCount
        do
            ldaa #VVramWidth
            staa <xCount
            do
                ldx <pVVram | ldaa 0,x
                ldx <pBackup | cmpa 0,x
                if ne
                    staa 0,x
                    bsr Put1
                else
                    ldx <pVram | inx | stx <pVram
                endif
                ldx <pVVram | inx | stx <pVVram
                ldx <pBackup | inx | stx <pBackup
                dec <xCount
            while ne | wend

            ldaa <pVram+1 | adda #low (VramRowSize-VVramWidth) | staa <pVram+1
            ldaa <pVram | adca #high (VramRowSize-VVramWidth) | staa <pVram
            dec <yCount
        while ne | wend
    pulb | pula
rts


; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
    Put_@Param0: public Put_@Param0
    Put_pVram: defw 0
    Put_@Param1: public Put_@Param1
    Put_c: defb 0
cseg
Put_: public Put_
    psha | pshb
        ldaa Put_c
        ldx Put_pVram | stx <pVram
        bsr Put1
    pulb | pula
    ldx <pVram
rts


; ptr<byte> PrintC(ptr<byte> <pVram, byte c);
dseg
    PrintC_@Param0: public PrintC_@Param0
    PrintC_pVram: defw 0
    PrintC_@Param1: public PrintC_@Param1
    PrintC_c: defb 0
cseg
PrintC_: public PrintC_
    psha | pshb
        ldx PrintC_pVram | stx <pVram
        ldaa PrintC_c
        cmpa #' '
        if eq
            clra
            bra PrintC_put
        endif
        cmpa #'-'
        if eq
            ldaa #1
            bra PrintC_put
        endif
        cmpa #'9'+1
        if cs
            adda #2-'0'
            bra PrintC_put
        endif
        adda #12-'A'
        PrintC_put:                     
        staa <pChars+1 | clr <pChars
        asl <pChars+1 | rol <pChars ;*2
        asl <pChars+1 | rol <pChars ;*4
        asl <pChars+1 | rol <pChars ;*8
        ldaa <pChars+1 | adda #low Ascii_ | staa <pChars+1
        ldaa <pChars | adca #high Ascii_ | staa <pChars
        
        ldab #CharHeight*2
        do
            ldx <pChars | ldaa 0,x | inx | stx <pChars
            ldx <pVram
            staa 0,x
            ldaa <pVram+1 | adda #VramWidth | staa <pVram+1
            decb
        while ne | wend
        ldaa <pVram+1 | adda #1-VramRowSize*2 | staa <pVram+1
    pulb | pula
    ldx <pVram
rts
